function [x_est, a_est, k] = CsDecSDMM(y, H, W, Wt, Phi, Phit, imsize, N, mu, alpha, gamma, p, nonorth, ItMax, tol)       
PsiH = @(z) W(real(ifft2(H.*fft2(z))));%reshape(W(real(ifft2(H.*fft2(z)))),imsize);
HPsit = @(z) real(ifft2(conj(H).*fft2(reshape(Wt(z),imsize))));

%--initilization--%
x = zeros(imsize);
w1 = zeros(N,1);%zeros(size(a));%a;%
w2 = zeros(imsize);%x_blur_est;(not as good as zeros)
w3 = zeros(imsize);%x_blur_est;%w1;
b1 = zeros(N,1);%zeros(size(a));%zeros(imsize);a;%
b2 = zeros(imsize);%w2;
b3 = b2;
       
k=0;
while k<ItMax
	temp = x;
    %% Step1
	x_nom = fft2(HPsit(w1-b1)) + fft2(w2-b2) + conj(H).*fft2(w3-b3);
	x_denom = conj(H).*H+1+conj(H).*H;
	x = real(ifft2(x_nom./x_denom));
        
    %% Step2       
	w1k = PsiH(x)+b1;
	factor = w1k./abs(w1k);
	factor(isnan(factor))=0;
	w1 = factor.*(max(abs(w1k)-gamma,0.0));                   

	w2k = b2 + x;
	[w2 ,chi] = prox_lp(w2k,p,alpha*gamma);
        
	if(nonorth)%\Phi is not orthogonal
        fvk_left = gamma*Phit(Phi(w3(:))) + mu*w3(:);
        fvk_right = gamma*Phit(y)+mu*b3(:)+mu*reshape(real(ifft2(H.*fft2(x))),[prod(imsize),1]);
        fvk = fvk_left-fvk_right;
        Pfvk = Phi(fvk);
        step_nom = fvk'*fvk;
        step_denom = gamma*Pfvk'*Pfvk + mu*fvk'*fvk;
        step = step_nom/step_denom;
        w3v = w3(:)-step*fvk;
        w3 = reshape(w3v,imsize);
            
	else %\Phi is orthogonal
        w3_nom = 1/gamma*(b3+real(ifft2(H.*fft2(x))))+1/mu*reshape(Phit(y),imsize);
        w3_1 = gamma*w3_nom;
        w3_2 = -gamma^2/(mu+gamma)*Phit(Phi(w3_nom(:)));
        w3 = real(w3_1 + reshape(w3_2,imsize));
	end
                      
    %% Step3
	b1 = b1 + PsiH(x) - w1;
	b2 = b2 + x - w2;
	b3 = real(b3 + ifft2(H.*fft2(x)) - w3);

	Hx = real(ifft2(H.*fft2(x)));
	PsiHx = W(Hx);
    
    MSE_t(k+1) = norm(x(:)-temp(:),2)/norm(x);%^2/n;
    fprintf('MSE_t = %.2e\n', MSE_t);  
    temp1 = MSE_t(k+1);   
    if(temp1<tol)
        break;
    end
    k = k+1;  
end
x_est = real(x);
a_est = w1;
